#include	<avr/io.h>
#include	<avr/interrupt.h>
#include	<stdio.h>
#include	"lcd.h"

#define	MAX_LCD_STRING	0x40

#define	GO_SW		PE7  // ADC   ġ
#define	MODE_SW	PE5  // /   ġ, 1:  0: 

#define	SINGLE_MODE		0
#define	FREE_MODE		1

#define	PRESSED	 	0
#define	RELEASED	 	1

volatile int  adc_rq=0, adc_result=0;
volatile unsigned  int  mode = SINGLE_MODE;

ISR(ADC_vect)
{	adc_result = ADC;
	adc_rq = 0;
}

ISR(INT5_vect)
{	mode = (PINE & 1<<MODE_SW) ? FREE_MODE : SINGLE_MODE;	}

void ADC_init(void)
{
	// ADC Ȱȭ, ADC ͷƮ Ȱȭ, Ϸ CPU ֺ=64
	ADCSRA |= 1<<ADEN | 1<<ADIE | 6;	
	
	// ܺ AREF , ADC ä (0,0,0,0,0):  ȣ ADC0 
}

// row, col ġ ڿ str LCD Ѵ.
void	LCD_str_write(unsigned int row, unsigned int col, char *str)
{
	int	i;
	
	set_cursor(row, col);
	for(i=0; (i+col < MAX_LCD_STRING) && (str[i] != '\0'); i++)
		LCD_data_write(str[i]);
}

enum {MODE_CONFIRM, ADC_START, ADC_DONE} state=MODE_CONFIRM;

//////////////////////////////////////////////////////////////
int	main(void)
{
	unsigned	int	prev_go_sw = 1, now_go_sw = 1;
	char lcd_string[2][MAX_LCD_STRING];
	
	ADC_init();
	LCD_init();
	
	EIMSK |= 1<<MODE_SW;		// MODE_SW ܺ ͷƮ Ȱȭ
	EICRB |= 1<<ISC50;		// (0, 1) Ʈ  ۵  ͷƮ
	DDRE &= ~(1<<GO_SW | 1<<MODE_SW); // GO_SW, MODE  Է 
	PORTE |= 1<<GO_SW | 1<<MODE_SW;	// GO_SW, MODE ɿ  Ǯ 

	sprintf(lcd_string[0], " << ADC TEST >>");
	sprintf(lcd_string[1], "ADC result= ");

	LCD_str_write(0, 0, lcd_string[0]);
	LCD_str_write(1, 0, lcd_string[1]);

	sei();		// start global interrupt
	mode = (PINE & 1<<MODE_SW) ? FREE_MODE : SINGLE_MODE; //  mode Ȯ
	
	while(1){
		switch( state ){
		case MODE_CONFIRM:
			if( mode == FREE_MODE ){
				ADCSRA |= 1<<ADFR;	//    
				adc_rq = 1;
				ADCSRA |= 1<<ADSC;	// A/D ȯ ٷ 
				state = ADC_DONE;
			}else{
				ADCSRA &= ~(1<<ADFR);	//    
				state = ADC_START;
			}
			break;
		
		case ADC_START:
			if( mode == SINGLE_MODE ){
				now_go_sw = (PINE & 1<<GO_SW) ? RELEASED : PRESSED;
				// ġ   
				if( prev_go_sw==RELEASED && now_go_sw==PRESSED){
					adc_rq = 1;
					ADCSRA |= 1<<ADSC;	// A/D ȯ 
					state = ADC_DONE;
				}
				prev_go_sw = now_go_sw;
			}else{
				state = MODE_CONFIRM;
			}	
			break;
		
		case ADC_DONE:
			while(adc_rq);		// ADC Ǳ⸦ ٸ
			
			sprintf(lcd_string[1], "%-4d", ADC);
			LCD_str_write(1, 12, lcd_string[1]);
			state = MODE_CONFIRM;
			break;
		}
	}
	return 0;
}
