#include	<avr/io.h>
#include	<avr/interrupt.h>
#include	<stdio.h>
#include	"lcd.h"

#define	F_CPU	8000000L

// RC   ȣ 
#define	TCNT2_PRESCALE	1024L
#define	RC_PWM_OC2	PB7		// RC  : PWM (OC2)  
#define RC_PWM_OCR2	OCR2	// RC  PWM OCR2 
#define	RC_PWM_NUTRAL	(int)((0.0015*F_CPU)/TCNT2_PRESCALE - 1)
#define	RC_PWM_PER_DEG	((double)((0.0008*F_CPU)/(double)(TCNT2_PRESCALE*90.0)))
#define	RC_PWM_DEGREE(degree)	(RC_PWM_NUTRAL + degree*RC_PWM_PER_DEG)

//   ֱ  ̺ ũ 
#define	SENOR_READ_INTERVAL		0.0012	// sec
#define	MOTOR_RETAIN_INTERVAL	0.15		// sec

#define	TCNT0_PRESCALE	8
#define	NUM_TCNT0		256		
#define	NUM_TIMER0_OVF_FOR_INERVAL(x)	((double)x*F_CPU/(TCNT0_PRESCALE*NUM_TCNT0))

#define	NUM_TIMER0_OVF_FOR_SENSOR		(int)NUM_TIMER0_OVF_FOR_INERVAL(SENOR_READ_INTERVAL)
#define	NUM_TIMER0_OVF_FOR_RETAIN		(int)NUM_TIMER0_OVF_FOR_INERVAL(MOTOR_RETAIN_INTERVAL)

// RC  ȸ  ̺
#define	DEG_L_MAX	90
#define	DEG_L_MID	45
#define	DEG_L_LOW	20
#define	DEG_L_VLOW	10
#define	DEG_ZERO	0
#define	DEG_R_MAX	-90
#define	DEG_R_MID	-45
#define	DEG_R_LOW	-20
#define	DEG_R_VLOW	-10

//  : (Left)   ȣ ̺
#define	L_PWM_OC1A	PB5	//  PWM  
#define	L_X	PA2
#define	L_Y	PA3
#define	L_MOTOR_PORT	PORTA
#define	L_MOTOR_DDR		DDRA
#define	L_CLAER	(L_MOTOR_PORT & ~(1<<L_X | 1<<L_Y))

//    ũ 
#define	L_MOTOR_FORWARD	(L_MOTOR_PORT = (L_MOTOR_PORT & L_CLAER) | 1<<L_X)
#define	L_MOTOR_BACKWARD	(L_MOTOR_PORT = (L_MOTOR_PORT & L_CLAER) | 1<<L_Y)
#define	L_MOTOR_STOP		(L_MOTOR_PORT = (L_MOTOR_PORT & L_CLAER) | 1<<L_X | 1<<L_Y)

//  : (Right)   ȣ ̺
#define	R_PWM_OC3A	PE3	//  PWM  
#define	R_X	PA0
#define	R_Y	PA1
#define	R_MOTOR_PORT	PORTA
#define	R_MOTOR_DDR		DDRA
#define	R_CLAER	(R_MOTOR_PORT & ~(1<<R_X | 1<<R_Y))

//    ũ 
#define	R_MOTOR_FORWARD	(R_MOTOR_PORT = (R_MOTOR_PORT & R_CLAER) | 1<<R_X)
#define	R_MOTOR_BACKWARD	(R_MOTOR_PORT = (R_MOTOR_PORT & R_CLAER) | 1<<R_Y)
#define	R_MOTOR_STOP		(R_MOTOR_PORT = (R_MOTOR_PORT & R_CLAER) | 1<<R_X | 1<<R_Y)

#define	L_PWM_OCR1A	OCR1A	//  PWM OCR1A 
#define	R_PWM_OCR3A	OCR3A	//  PWM OCR3A 

#define	LED_BLACK_AT_LEFT	PD1	//     LED  
#define	LED_BLACK_AT_RIGHT	PD0	//     LED  

#define	AC_IRBL	PF0		//  ܼ    ä
#define	AC_IRBR	PF1		//  ܼ    ä

// DC   ӵ ̺
#define	FULL_SPEED	0x3FF
#define	MID_SPEED	0x300
#define	LOW_SPEED	0x100
#define	STOP_SPEED	0

// line sensor
#define	____	0
#define	___X	1
#define	X___	2
#define	X__X	3

#define	SENSOR_LEFT		0
#define	SENSOR_RIGHT	1

//----- Ÿ̸/ī ͷƮ  
volatile	unsigned	long	timer0 = 0;
volatile	unsigned	char	sensor;
volatile	int		req_delay=0;
volatile	unsigned	int		irbl=0, irbr=0, test_sensor = SENSOR_LEFT;

//--    ڷ
enum	state_t	{DELAY_WAIT, DRIVE_DECISION};
enum	direction_t	{ STOP, FORWARD, BACKWARD, LEFT, RIGHT, ROTATE_LEFT, ROTATE_RIGHT};
enum 	state_t		state = DELAY_WAIT;

//-- Ÿ̸/ī0 ÷ ͷƮ
ISR(TIMER0_OVF_vect)
{	
	timer0++;
	if( timer0 % NUM_TIMER0_OVF_FOR_SENSOR == 0){//   ð ˻
		if( test_sensor == SENSOR_LEFT){		//    ?
			irbl = ACSR & 1<<ACO;				//  ܼ   : 1 or 0
			PORTD = irbl ? (PORTD | 1<<LED_BLACK_AT_LEFT) : (PORTD & ~(1<<LED_BLACK_AT_LEFT)); 	//      LED 
			ADMUX = (ADMUX & ~0x1F) | AC_IRBR;	//    ġ  AC_IRBR äη 
			test_sensor = SENSOR_RIGHT;
		}else{
			irbr = ACSR & 1<<ACO;				//  ܼ   : 1 or 0
			PORTD = irbr ? (PORTD | 1<<LED_BLACK_AT_RIGHT) : (PORTD & ~(1<<LED_BLACK_AT_RIGHT)); //      LED 
			ADMUX = (ADMUX & ~0x1F) | AC_IRBL;	//    ġ  AC_IRBL äη 
			test_sensor = SENSOR_LEFT;
		}
		sensor = 2*(irbl || 0) + (irbr || 0);	//    ____, ___X, X___, X__X  ȯ
	}
	
	// delay ð 
	if(req_delay > 0)	req_delay--;
}

// , ޹ ȸ , ũ   ӽð  Լ
#define	STRENGTH	0x200
void	drive(enum	direction_t direction, int delay)
{
	req_delay = NUM_TIMER0_OVF_FOR_RETAIN * delay;
	
	switch( direction ){
	case FORWARD:						//  
		L_MOTOR_FORWARD;	R_MOTOR_FORWARD;
		L_PWM_OCR1A = MID_SPEED;		//   PWM ȣ 
		R_PWM_OCR3A = MID_SPEED;		//   PWM ȣ 
		RC_PWM_OCR2 = RC_PWM_DEGREE(DEG_ZERO);	// ޹ PWM ȸȣ
		break;

	case LEFT:
		L_MOTOR_BACKWARD;	R_MOTOR_FORWARD;
		L_PWM_OCR1A = STOP_SPEED + STRENGTH;		//   PWM ȣ 
		R_PWM_OCR3A = MID_SPEED;		//   PWM ȣ 
		RC_PWM_OCR2 = RC_PWM_DEGREE(DEG_R_MAX);	// ޹ PWM ȸȣ
		break;

	case RIGHT:
		L_MOTOR_FORWARD;	R_MOTOR_BACKWARD;
		L_PWM_OCR1A = MID_SPEED;		//   PWM ȣ 
		R_PWM_OCR3A = STOP_SPEED + STRENGTH;		//   PWM ȣ 
		RC_PWM_OCR2 = RC_PWM_DEGREE(DEG_L_MAX);	// ޹ PWM ȸȣ
		break;

	case BACKWARD:
		L_MOTOR_BACKWARD;	R_MOTOR_BACKWARD;
		L_PWM_OCR1A = STOP_SPEED + STRENGTH;		//   PWM ȣ 
		R_PWM_OCR3A = STOP_SPEED + STRENGTH;		//   PWM ȣ 
		RC_PWM_OCR2 = RC_PWM_DEGREE(DEG_ZERO);	// ޹ PWM ȸȣ
		break;

	case ROTATE_LEFT:
		L_MOTOR_BACKWARD;	R_MOTOR_FORWARD;
		L_PWM_OCR1A = MID_SPEED;		//   PWM ȣ 
		R_PWM_OCR3A = MID_SPEED;		//   PWM ȣ 
		RC_PWM_OCR2 = RC_PWM_DEGREE(DEG_L_MAX);	// ޹ PWM ȸȣ
		break;

	case ROTATE_RIGHT:
		L_MOTOR_FORWARD;	R_MOTOR_BACKWARD;
		L_PWM_OCR1A = MID_SPEED;		//   PWM ȣ 
		R_PWM_OCR3A = MID_SPEED;		//   PWM ȣ 
		RC_PWM_OCR2 = RC_PWM_DEGREE(DEG_L_MAX);	// ޹ PWM ȸȣ
		break;

	default: 	// STOP
		L_MOTOR_STOP;	R_MOTOR_STOP;
		L_PWM_OCR1A = STOP_SPEED;		//   PWM ȣ 
		R_PWM_OCR3A = STOP_SPEED;		//   PWM ȣ 
		RC_PWM_OCR2 = RC_PWM_DEGREE(DEG_ZERO);	// ޹ PWM ȸȣ
		break;
	}
}

//-- DC  Ʈ  
void	DC_MOTOR_PIN_init(void)
{
	L_MOTOR_DDR |= 1<<L_X | 1<<L_Y;		//   ȣ ⼳
	R_MOTOR_DDR |= 1<<R_X | 1<<R_Y;		//   ȣ ⼳
}

//-- DC  PWM ȣ ߻ ʱȭ Ÿ̸/ī1, 3 10Ʈ  PWM 
void	DC_MOTOR_PWM_init(void)
{
	TCCR1B |= 1<<WGM12;		// 10 Ʈ  PWM ߻
	TCCR1A |= 1<<WGM11 | 1<<WGM10;
	TCCR1B |= 1<<CS12;		// 256 
	TCCR1A |= 1<<COM1A1;	// OCR1A Ű Ƽ 
	
	TCCR3B |= 1<<WGM32;		// 10 Ʈ  PWM ߻
	TCCR3A |= 1<<WGM31 | 1<<WGM30;
	TCCR3B |= 1<<CS32;		// 256 
	TCCR3A |= 1<<COM3A1;	// OCR3A Ű Ƽ 

	DDRB |= 1<<L_PWM_OC1A;		// PORTB PB5(OC1A) ¹ 
	DDRE |= 1<<R_PWM_OC3A;		// PORTB PE3(OC3A) ¹ 

	TCNT3 = TCNT1 = 0;		// Ÿ̸ ʱȭ
}

//---- RC  PWM ʱȭ Ÿ̸/ī2 ,  PWM 
void	RC_MOTOR_PWM_init(void)
{
	DDRB |= 1<<RC_PWM_OC2;			// OC2 output : RC  PWM 

	TCCR2 = 1<<WGM21 | 1<<WGM20;	// TCNT2  PWM ߻
	TCCR2 |= 1<<CS22 | 1<<CS20;		// Ϸ CS22:20 = (1,0,1) 1024 
	TCCR2 |= 1<<COM21;				// TCNT2 0xFF 1, µ OCR2 ġϸ 0
}

//-- ֱ  а, ð   Ÿ̸/ī0 ÷ 
void	TIMER0_init()
{
	TIMSK |= 1<<TOIE0;		// Ÿ̸0 ÷ ͷƮ Ȱȭ
	TCCR0 |= 1<<CS01;		// Ϸ : 8, Ϲ 
}

//---- main() Լ
int	main(void)
{	char lcd_string[2][MAX_LCD_STRING];

	LCD_init();
	DC_MOTOR_PIN_init();
	DC_MOTOR_PWM_init();
	RC_MOTOR_PWM_init();
	TIMER0_init();	

	DDRD |= 1<<LED_BLACK_AT_LEFT | 1<<LED_BLACK_AT_RIGHT;	//   ǥ LED
	
	SFIOR |= 1<<ACME;		// Ƴα׺񱳱 Է ADC5, 4,  AIN0
	ADMUX = 1<<REFS0 | AC_IRBL;		// Vmax = AVCC,   П
	sei();

	sprintf(lcd_string[0], "Black Line Trace");	LCD_str_write(0, 0, lcd_string[0]);
	while(1){
		switch(state){
		case DELAY_WAIT:
			while(req_delay);		// delay
			state = DRIVE_DECISION;
			break;

		case DRIVE_DECISION:
			if( sensor == ____)		drive(FORWARD, 0);
			else if(sensor == ___X)	drive(RIGHT, 1);
			else if(sensor == X___)	drive(LEFT, 1);
			else					drive(BACKWARD, 3);
			state = DELAY_WAIT;
			break;
		}

		// LCD ÷
		sprintf(lcd_string[1], "L:%-3X R:%-3X B:%-2X", L_PWM_OCR1A, R_PWM_OCR3A, RC_PWM_OCR2);
		LCD_str_write(1, 0, lcd_string[1]);
	}
	return 0;
}
