#include	 <avr/io.h>
#include	 <util/delay.h>

#define	 PRESSED		1
#define	 RELEASED	0
#define	 DEBOUNCE_MS	100

#define	AC	PB6
#define	BD	PB7
#define	MOTOR_PORT	PORTB
#define	MOTOR_DDR	DDRB
#define	CLAER	(MOTOR_PORT & 0x3F)

#define	MOTOR_STOP	(1<<AC | 1<<BD)
#define	MOTOR_FORE	(1<<BD)
#define	MOTOR_BACK	(1<<AC)

unsigned char digit[] = {0x77, 0x41, 0x3B, 0x5B, 0x4D, 0x5E, 0x7C, 0x43, 0x7F, 0x4F};

void	display_7segled(unsigned char led[], unsigned int number)
{	PORTC = led[number];	}

int	main(void)
{
	int	number;
	int	before;
	
	DDRC = 0xFF;			// 7-׸Ʈ LED Ʈ
	DDRD = DDRD & ~(1<<PD0);		// ġ Է
	PORTD = PORTD | 1<<PD0;		// ġ Է Ǯ  
	
	MOTOR_DDR |= 1<<AC | 1<<BD;	// Ʈ ȣ  
	MOTOR_PORT = (MOTOR_PORT & CLAER) | MOTOR_STOP;	// ʱ STOP

	number = 0;
	before = RELEASED;
	
	while(1){
		display_7segled(digit, number % 10);
		
		if( before==RELEASED && !(PIND & 1<<PD0) ){
			number++;
			_delay_ms(DEBOUNCE_MS);
			before = PRESSED;
		}else if( before==PRESSED && (PIND & 1<<PD0) ){
			_delay_ms(DEBOUNCE_MS);
			before = RELEASED;
		}
		
		if( number % 10 == 1)
			MOTOR_PORT = (MOTOR_PORT & CLAER) | MOTOR_FORE;
		else if(number % 10 == 3)
			MOTOR_PORT = (MOTOR_PORT & CLAER) | MOTOR_BACK;
		else
			MOTOR_PORT = (MOTOR_PORT & CLAER) | MOTOR_STOP;
	}
	return 0;
}
