#include	<avr/io.h>

#define	RS	PD5	// LCD  ÷̿  DƮ  ȣ 
#define	RW	PD6
#define	E	PD7

void	gen_E_strobe(void)
{	volatile	int	i;

	PORTD |= 1<<E;		// E ȣ High
	for(i=0; i<10; i++);		// E Ʈκ ȣ  Ⱓ High 
	PORTD &= ~(1<<E);		// E ȣ Low
}	

void	wait_BusyFlag(void)
{	volatile int 		i;
	unsigned char		bf;

	DDRC = 0x0;			         // CƮ Է 
	PORTD = (PORTD & ~(1<<RS)) | 1<<RW; // RS <- Low, RW <- High
	do{
		PORTD |= 1<<E;		// E ȣ High
		for(i=0; i<10; i++);	// E Ʈκ ȣ  Ⱓ High 
		bf = PINC & 1<<PC7;	// busy flag о
		PORTD &= ~(1<<E);	// E ȣ Low
	}while( bf );			// bf  0 ƴϸ busy, 0  ݺ
}

void	LCD_command(unsigned char data)
{	wait_BusyFlag();		// busy flag 0   
	DDRC = 0xFF;			// CƮ  
	PORTC = data;			// data 
	PORTD &= ~(1<<RS | 1<<RW);	// RS <- 0, RW <-0
	gen_E_strobe();		// E Ʈκ ȣ 
}

void	LCD_data_write(unsigned char data)
{	wait_BusyFlag();
	DDRC = 0xFF;
	PORTC = data;
	PORTD = (PORTD | 1<<RS) & ~(1<<RW); // RS <- 1, RW <-0
	gen_E_strobe();
}

void	LCD_init(void)
{
	DDRD |= 1<<RS | 1<<RW | 1<<E;	// RS, RW, E   
	PORTD &= ~(1<<RS | 1<<E | 1<<RW); 	// ʱ⿡ RS, E, RW <- 0

	LCD_command(0x3C);
	LCD_command(0x02);
	LCD_command(0x01);
	LCD_command(0x06);
	LCD_command(0x0F);
}

char *string[] = {"ATmega128", "Microcontroller"};

int	main(void)
{	int	r, c;
	
	LCD_init();

	for(r=0; r<2; r++){
		for(c=0; c<16; c++)
			if( string[r][c] == '\0' ){
				if( r==0 )	LCD_command( 0xc0);
				break;
			}else
				LCD_data_write( string[r][c]);
	}
		
	while(1);
	return 0;
}
