#include <avr/io.h>
#include <avr/interrupt.h>

#define	F_CPU	16000000UL
#define	PRESCALE			256L
#define	PULSE_PER_OVERFLOW	256L
#define	MS_OVERFLOW_CYCLE	((double)(PULSE_PER_OVERFLOW * PRESCALE) \
				/(double)((double)F_CPU/1000.0))
#define	NUM_REQ	3

volatile	 unsigned  long	timer0;	   // ÷θ 1  
volatile	 unsigned  long	req_timer0[NUM_REQ] = {0, 0, 0};	// û 

volatile unsigned  int	number;	   // Ǿ 7-׸Ʈ LED ÷̵ 
unsigned char led[] = {0x48, 0x7D, 0xC4, 0x64, 0x71, 0x62, 0x43, 0x7C, 0x40, 0x70};

// ms_interval  ð   ÷ Ƚ  Լ
unsigned long	ms_req_timer0(unsigned long ms_interval)
{	return ( ms_interval <= 0.0) ? 0 : \
			(unsigned long)(ms_interval / MS_OVERFLOW_CYCLE); 
}

// Ÿ̸/ī0 ͷƮ  ƾ
ISR(TIMER0_OVF_vect)
{	int	i;

	timer0++;		  // ÷θ 1 
	
	// ÷ Ƚ 4   10ڸ Ȥ 2   1ڸ ÷
	if(timer0 % 2 == 0){	
		PORTC = (timer0%4 == 0) ? led[(number%100) / 10] : led[number%10];
		PORTD = (PORTD |0xC0) & ~(1<<((timer0 % 4 == 0) ? PD7 : PD6));
	}
	for(i=0; i<NUM_REQ; i++)	  // û ð   ˻  
		if( req_timer0[i] > 0)
			req_timer0[i]--;
}
	
int	main(void)
{	
	DDRC = 0xFF;
	DDRD |= 1<<PD7 | 1<<PD6;	  // ư 7-׸Ʈ LED ѱ 
	DDRB |= 1<<PB7 | 1<<PB6;	  // ð   LED ON/OFF  
	
	TCCR0 = 1<<CS02 | 1<<CS01;	// 256  
	TIMSK |= 1<<TOIE0;		// Ÿ̸/ī0 ͷƮ Ȱȭ
	
	timer0 = 0;
	sei();

	number = 0;
	
	while(1){
		if( req_timer0[0] == 0){		// 50[ms]   Ȯ
			PORTB ^= 1<<PB7;		// PD0  
			req_timer0[0] = ms_req_timer0(50);  // 50[ms]  û
		}
		if( req_timer0[1] == 0){	       // 1000[ms]   Ȯ
			PORTB ^= 1<<PB6;	       // PD1  
			req_timer0[1] = ms_req_timer0(1000);  // 1000[ms]  û
		}
		if( req_timer0[2] == 0){	// 1000ms  Ȯ
			number++;	// 7-׸Ʈ LED ÷̿ number 
			req_timer0[2] = ms_req_timer0(1000); // 1000[ms]  û
		}
	}
	
	return 0;
}
