#include <avr/io.h>
#include	 <avr/interrupt.h>

#define	F_CPU	16000000UL
#define	PRESCALE			256L
#define	PULSE_PER_OVERFLOW	510L
#define	MS_OVERFLOW_CYCLE	((double)(PULSE_PER_OVERFLOW * PRESCALE) \
				/(double)((double)F_CPU/1000.0))

#define	OC0		PB4

#define	UP		PB7
#define	DOWN	PB6

#define	NUM_REQ		2
#define	REQ_UP		0
#define	REQ_DOWN	1
#define	DEBOUNCE_CYCLE	50

volatile	unsigned	long	timer0;		// ÷θ 1  
volatile	unsigned	int		number;
unsigned char led[] = {0x48, 0x7D, 0xC4, 0x64, 0x71, 0x62, 0x43, 0x7C, 0x40, 0x70};

volatile	unsigned	long	req[NUM_REQ] = {0, 0};
double		ms_ov_cycle;

// Ÿ̸/ī0 ͷƮ  ƾ
SIGNAL(SIG_OVERFLOW0)
{	int	i;

	timer0++;		// ÷θ 1 
	
	// ÷ Ƚ ¦  10ڸ, Ȧ  1ڸ ÷
	PORTC = (timer0 % 2 == 0) ? led[(number % 100) / 10] : led[number%10];
	PORTD = (PORTD |0xC0) & ~(1<<((timer0 % 2 == 0) ? PD7 : PD6));
	
	for(i=0; i<NUM_REQ; i++)
		if( req[i] > 0)		// REQ û   
			req[i]--;		// ð   
}

// ms_interval ð   ÷ Ƚ  Լ
unsigned long	ms_req_timer0(unsigned long ms_interval)
{	return ( ms_interval <= 0) ? 0 : \
			+ (unsigned long)(ms_interval / ms_ov_cycle); 
}

int	main(void)
{	
	DDRC = 0xFF;
	DDRD |= 1<<PD7 | 1<<PD6;	//  ڸ 7-׸Ʈ LED ѱ 
	DDRB |= 1<<OC0;		// OC0 = PB4 
	DDRB &= ~(1<<UP | 1<<DOWN);	// UP, DOWN ġ ġ Է 
	PORTB |= 1<<UP | 1<<DOWN;	// UP, DOWN Ǯ 

	TCCR0 = 1<<WGM00;              //  PWM  ߻
	TCCR0 |= 1<<CS02 | 1<<CS01;   // Ϸ CS02:00 = (1,1,0) 256 
	TCCR0 |= 1<<COM01;		//   OCR0 ġ 0, ϰ  ġ 1
	
	TIMSK |= 1<<TOIE0;		// Ÿ̸/ī0 ͷƮ Ȱȭ
	
	timer0 = 0;
	sei();

	ms_ov_cycle	= MS_OVERFLOW_CYCLE;

	OCR0 = 0;
	number = OCR0*100/256;	// OCR0  number  ġ
	
	while(1){
	  if( (req[REQ_UP]==0) && !(PINB & (1<<UP))){ //req[UP], UP ġ  ˻
		 req[REQ_UP] = ms_req_timer0(DEBOUNCE_CYCLE);
		 OCR0 = (OCR0 == 255) ? 255 : OCR0 + 1;
	  }
			
	  if( (req[REQ_DOWN]==0) && !(PINB & (1<<DOWN))){ //req[DOWN],DOWN ġ ˻
		 req[REQ_DOWN] = ms_req_timer0(DEBOUNCE_CYCLE);
	     OCR0 = (OCR0 == 0) ? 0 : OCR0 - 1;
	  }

	  number = OCR0 * 100/256;
	}
	
	return 0;
}
